<?php

namespace Drupal\eudonet\Exception;

use Drupal\eudonet\Plugin\EudonetQueryResultBase;

/**
 * Thrown when an Eudonet Query fails to execute.
 */
class QueryException extends EudonetException {

  public function __construct(
    string $message = "",
    int $code = 0,
    ?Throwable $previous = NULL,
    /** @var \Drupal\eudonet\Plugin\EudonetQueryResultBase */
    protected $queryResult = NULL,
  ) {
    if ($queryResult) {
      $message = $queryResult->getErrorMessage();
      $code = $queryResult->getErrorNumber();
    }

    parent::__construct($message, $code, $previous);
  }

  public function getQueryResult(): EudonetQueryResultBase {
    return $this->queryResult;
  }

}
