<?php

namespace Drupal\eudonet\Model;

class AuthToken {

  public function __construct(
    protected string $value,
    /**
     * Eudonet Server timestamp at the time of creation.
     *
     * @var int
     */
    protected \DateTime $createdAt,
    /**
     * Timestamp of the token's expiry.
     *
     * @var int
     */
    protected \DateTime $expiresAt,
  ) {}

  /**
   * Get the token value.
   *
   * @return string
   *   Token value.
   */
  public function getValue(): string {
    return $this->value;
  }

  public function isExpired(): bool {
    // @todo Understand and document why "+2 hours".
    //   Consider using "+1 minute" or "+5 minutes".
    return $this->expiresAt->getTimestamp() < strtotime('+2 hours');
  }

  public function getCreatedAt(): \DateTime {
    return $this->createdAt;
  }

  public function getExpiresAt(): \DateTime {
    return $this->expiresAt;
  }

}
