<?php

namespace Drupal\eudonet\Plugin\EudonetQueryResult;

use Drupal\eudonet\Eudonet;
use Drupal\eudonet\Model\AuthToken;
use Drupal\eudonet\Plugin\EudonetQueryResultBase;

/**
 * Class AuthenticationQueryResult.
 *
 * @package Drupal\eudonet\Plugin\EudonetQueryResult
 *
 * @EudonetQueryResult(
 *   id = "eudonet_authentication_query_result",
 *   label = @Translation("Authentication query result")
 * )
 */
class AuthenticationQueryResult extends EudonetQueryResultBase {

  /**
   * Get the token from the Eudonet API response.
   *
   * @return \Drupal\eudonet\Model\AuthToken
   *   A token.
   */
  public function getToken(): AuthToken {
    return new AuthToken(
      $this->response['ResultData']['Token'],
      new \DateTime($this->response['ResultData']['ServerDate']),
      new \DateTime($this->response['ResultData']['ExpirationDate']),
    );
  }

}
