<?php

namespace Drupal\eudonet\Traits;

/**
 * Trait EudonetQueryFieldTrait.
 *
 * @package Drupal\eudonet\Traits
 */
trait EudonetQueryFieldTrait {

  protected array $fields = [];

  /**
   * Add a field.
   *
   * @param int|string $field_name
   *   The field name to get in the request response.
   *
   * @return $this
   */
  public function addField(int|string $field_name): static {
    if (method_exists($this, 'ensureMapping')) {
      $this->ensureMapping();
    }

    $field_id = empty($this->mapping[$field_name]) ? $field_name : $this->mapping[$field_name];
    $this->fields[] = $field_id;

    return $this;
  }

  /**
   * Add multiple fields.
   *
   * @param string[] $field_names
   *   An array of field names to get in the request response.
   *
   * @return $this
   */
  public function addFields(array $field_names): static {
    foreach ($field_names as $field_name) {
      $this->addField($field_name);
    }

    return $this;
  }

}
