<?php

namespace Drupal\eudonet\Traits;

/**
 * Eudonet Query Pager Trait.
 *
 * @package Drupal\eudonet\Traits
 */
trait EudonetQueryPagerTrait {

  protected array $pager = [];

  /**
   * Define the pager for the request.
   *
   * @param int $limit
   *   Number of items per page.
   * @param int $page
   *   Page index, where 0 is the first page.
   *
   * @return $this
   */
  public function pager(int $limit = 0, int $page = 0): static {
    $this->pager = [
      'RowsPerPage' => $limit,
      'NumPage' => $page,
    ];

    return $this;
  }

}
